【CodeForces-455A】解题报告(DP,long long)
原始题目
A. Boredom
- time limit per test 1 second
- memory limit per test 256 megabytes
- input standard input
- output standard output
Alex doesn't like boredom. That's why whenever he gets bored, he comes up with games. One long winter evening he came up with a game and decided to play it.
Given a sequence a consisting of n integers. The player can make several steps. In a single step he can choose an element of the sequence (let's denote it ak) and delete it, at that all elements equal to ak + 1 and ak - 1 also must be deleted from the sequence. That step brings ak points to the player.
Alex is a perfectionist, so he decided to get as many points as possible. Help him.
Input
The first line contains integer n (1 ≤ n ≤ 105) that shows how many numbers are in Alex's sequence.
The second line contains n integers a1, a2, ..., an (1 ≤ ai ≤ 105).
Output
Print a single integer — the maximum number of points that Alex can earn.
Examples
input
2
1 2
output
2
input
3
1 2 3
output
4
input
9
1 2 1 3 2 2 2 2 3
output
10
Note
Consider the third test example. At first step we need to choose any element equal to 2. After that step our sequence looks like this [2, 2, 2, 2]. Then we do 4 steps, on each step we choose any element equals to 2. In total we earn 10 points.
题目大意
给出一个数列a1,a2,a3...ai...an。每次选定一个数ai,并且所有与ai-1,ai+1相等的数全部消去,这样消去一次得分为ai。最终把数列全部消去完,问最终最高得分是多少。
解题思路
dp,数组A[ai]表示ai出现的次数,并且记录最大值mmax,从0到mmax走一遍dp。
状态转移方程为dp[i]=max(dp[i-1],dp[i-2]+A[i]*i),即从小到大消去到ai=i时的最高得分为:消去到i-1的最高得分(因为消去i-1时所有i=i-1+1全部被消去)与消去到i-2的最高得分加上消去A[i]个i的得分(即跳过i-1不消去)。
由于涉及求和,ai乘上出现次数会超int范围,故使用long long。
解题代码
1 |
|
收获与反思
建立好状态转移方程就好,注意long long。
本博客所有文章除特别声明外,均采用 CC BY-SA 4.0 协议 ,转载请注明出处!